#ifndef UIINTERFACEFORBACKSTAGE
#define UIINTERFACEFORBACKSTAGE

#include "UiTools.h"
#include <chrono>

class UiInterfaceForBackstage : public WidgetWithBackstageInterface
{
public:
    typedef enum
    {
        PLATFORM_CONNECTION_STATUS_DISCONNECTED,
        PLATFORM_CONNECTION_STATUS_CONNECTED,
        PLATFORM_CONNECTION_STATUS_LOGGED
    }PLATFORM_CONNECTION_STATUS_E;

	typedef enum
	{
		QRCode_Msg_Standby,
		QRCode_Msg_GreenCode,
		QRCode_Msg_YellowCode,
		QRCode_Msg_RedCode,
		QRCode_Msg_Verifying,
		QRCode_Msg_Error,
        QRCode_Msg_OtherCode,
        QRCode_Msg_Overtime
	}QRCode_Msg_E;

    virtual long long getUiVersion() = 0;

    virtual void showUnauthorizedPage() = 0;
    virtual void showScreenSaverPage() = 0;

    virtual void showRecoMsgReco() = 0;
    virtual void showRecoMsgRetry() = 0;
    virtual void showRecoMsgFail(int failType) = 0;
    virtual void notifyFaceInfo(const bool faceAvailable) = 0;
    virtual void showRecoSuccess(const char *name) = 0;
    virtual void showRecoMsgIDFail() = 0;

    virtual int showFaceImg(const unsigned char *imgData, const int imgLen) = 0;
    virtual void updatePlatformConnectionStatus(const PLATFORM_CONNECTION_STATUS_E) = 0;

    virtual void showRecoMsgMoveForehead() = 0;                         //移动到额头区
    virtual void showRecoMsgForeheadNormalTemp(const float temp, const bool isC) = 0;   //显示正常温度
    virtual void showRecoMsgForeheadAbnormalTemp(const float temp, const bool isHigh, const bool isC) = 0; //显示异常温度

    virtual void showRecoMsgReadTempFailed() = 0;   //体温检测失败
    virtual void showRecoMsgNoMaskWarn() = 0;       //请戴口罩
    virtual void showRecoMsgMaskOk() = 0;
	virtual void showRecoMsgMaskWarn() = 0;

    virtual void showRecoMsgNoEntry(const bool) = 0;          //显示禁止通行

    virtual void turnOffScanLine() = 0;

    virtual void clearLocalFacePage() = 0;  //清除本地人脸库数据，在平台清空本地人脸的时候
    virtual void updateLogo(const enLogo) = 0;      //更新logo

    virtual void showQRCodeMsg(const QRCode_Msg_E) = 0;
    virtual void showQRCodeReco() = 0;
    virtual void showFaceReco() = 0;
	virtual void updateRecoUiIp() = 0;

    virtual void showFeatureUpdateProgress(const unsigned current, const unsigned all) = 0;
    virtual void closeFeatureUpdateProgress() = 0;

    virtual void showRecoUiMask(int maskType) = 0;

    virtual void showNotiMsg(const char *msg, int color) = 0;

    virtual void updateScreenSaver() = 0;

    virtual int grabScreen(const QString& picName, int rotate = 0) = 0;

    virtual void showDrawPage() = 0;
	virtual int switchToRecoUi() = 0;

    virtual int showCenterMsg(const char* msg, int type) = 0;

	virtual int showUserPwd(const char* name) = 0;
	virtual	void setPwdButton(bool visible) = 0;
	virtual void showPwdUiPersonName(const char* name) = 0;
	virtual void showUserPwdError(int type, int color) = 0;
	virtual void showUserCandidate(const char* title, const char** opns, int opnsNum) = 0;
	virtual void showDevTestPage(const char* devCfgMsg) = 0;
	virtual void setDevTestMesAddrAndProdNoText(const char* text) = 0;
	virtual void setDevTestPcbSeqText(const char* text) = 0;
	virtual void setDevTestConfigInfo(const char* text) = 0;

	virtual void showOrHideFaceFrame(bool show) = 0;
	virtual void showPassResult(bool pass) = 0;

	virtual void showRecoUiColorFaceSnapshot(const char* path) = 0;
	virtual void showRecoUiColorFaceSnapshot(const unsigned char* jpgDate, int len) = 0;
	virtual void recoUiswitchToType(int type) = 0;

	virtual void qrcodeFastCfgResult(bool isSuccessed) = 0;

    virtual void icCardResult(const char *icCardNum) = 0;

	virtual void showHealthMsg(int type, float temp, const char * msg, bool pass, const unsigned char* jpgDate, 
		int jpgLen, const char * tripCity, const char* failReason, int bgColor, int displayTime) = 0;
	virtual void showHealthCodeAuthStatus(int status) = 0;
	virtual void showAntiDismantleDetect(bool upload) = 0;
	virtual void showSceneResult(int result, const char* resultText, const char* businessInfo, int displayTime) = 0;
	virtual void updatePersonNumAccessed(int personAccess, int personAll) = 0;
	virtual bool isScenePassing() = 0;
	virtual void setSceneUiPersonCountType(int type) = 0;
	virtual void updateSceneUiPersonCount(int count) = 0;
	virtual void showCallDialPage() = 0;
	virtual void setCallConsoleStatus(int status, const char* tip) = 0;
    virtual void setDndMode(bool enabled, const std::chrono::system_clock::time_point &time) = 0;
	virtual void showRecoUiDevIdAndVer(bool show) = 0;
	virtual void showUserItemChoose(const std::vector<std::string>& items) = 0;
};


#endif // UIINTERFACEFORBACKSTAGE

