#ifndef SETTINGUIACCMNG_H
#define SETTINGUIACCMNG_H

#include <QListWidget>
#include "UiTools.h"

class settingUiAccMng : public SettingUiPage
{
    Q_OBJECT
public:
    typedef enum
    {
        enAccOpenDelay,
        enAccOpenTime,
        enAccOpenSig,
        enAccRs485ReverseAccessSw,  // RS485反向通行
        //enAccAlmSig,
        enAccRs485,
        enAccRs485Prot1Addr,
        enAccRs485Prot3Cfg,
        enAccGPIO4,
        enAccGPIO5,
        enAccDoorCloseOvertime,
        enAccAntiDemolitionSw,
        enAccAntiDemolitionOutput,
    }enAcc;

    static int m_pageIndex;

    explicit settingUiAccMng(int pageIndex, QWidget *parent = nullptr);
    ~settingUiAccMng();
    void setBackstageUiinterface(BackstageInterfaceForUi* interface);
    void reset();

signals:

public slots:
    void slotItemClicked(QListWidgetItem* item);

private:
    const QVector<QString> OpenSig{
	    tr("禁用"),
	    tr("本地继电器"),
	    tr("韦根26"),
	    tr("韦根34"),
	    tr("韦根42"),
	    tr("RS485")
    };

    const QVector<QString> AlarmSig{
        tr("禁用"),
        tr("本地继电器")
    };

	const QVector<QString> Rs485Cfg{
	    tr("禁用"),
	    tr("协议1"),
	    tr("协议2"),
	  	tr("协议3")
    };

	const QVector<QString> GPIOCfg{
	    tr("禁用"),
	    tr("门磁"),
	    tr("消防信号")
    };

	const QVector<QString> AntiDemolitionOutput{
	    tr("无"),
	    tr("本地继电器"),
	    tr("GPIO4"),
	    tr("GPIO5")
    };
};

#endif // SETTINGUIACCMNG_H
