#ifndef SETTINGUISYSMNG_H
#define SETTINGUISYSMNG_H

#include <QListWidget>
#include "UiTools.h"
#include "UiConfig.h"

class settingUiSysMng : public SettingUiPage
{
    Q_OBJECT
public:
    typedef enum
    {
        SYS_MNG_LANGUAGE,
        SYS_MNG_DATA_ENCRYPT,
        SYS_MNG_AUTO_REBOOT,
        SYS_MNG_AUTO_REBOOT_TIME,
        SYS_MNG_AUTO_REBOOT_INTERVAL,
        SYS_MNG_MAN_REBOOT,
        SYS_MNG_SERVER_ADDR,
        SYS_MNG_CLEAR_DATA,
        SYS_MNG_RESTORE
    }SYS_MNG_E;

    static int m_pageIndex;

    explicit settingUiSysMng(int pageIndex, QWidget *parent = nullptr);
    ~settingUiSysMng();
    void setBackstageUiinterface(BackstageInterfaceForUi *interface);
    void reset();

signals:

public slots:
    void slotItemClicked(QListWidgetItem*);
    void slotSysReboot();

private:
    //简 繁 英 日 韩           西班牙 泰 葡萄牙 意大利 希伯来 法 德 土耳其 匈牙利
    const QVector<QString> Language{"简体中文", "繁體中文", "English", "日本語", "한국어.", 
									"Español", "ภาษาไทย", "Português", "Italiano", "היברית", 
									"Français", "Deutsch", "Türkçe", "Magyar"};
	#ifdef __HIMIX200__
	const QVector<bool> LanguageSup = {true, true, true, true, true, 
										true, true, true, true, true, 
										true, true, true, true};
	#else										
    const QVector<bool> LanguageSup = {true, true, true, true, true, 
										false, false, false, true, false, 
										false, false, false, false};
	#endif										
};


#endif // SETTINGUISYSMNG_H
